#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#define LIST_LEN(x) ((int)(sizeof((x)) / sizeof((x)[0])))

#define GET_OFFS(x) ((x) & 0x00FFFFFFUL)
#define GET_BYTE(x) ((x) >> 24)

#pragma pack(push, 1)
/*
  packed data type
  {0x@@######UL, 0x$$}
  @@ - old byte
  $$ - new byte
  ###### - offset
*/
typedef struct {
  unsigned long offs;
  unsigned char data;
} fix_item;
#pragma pack(pop)

/* invert mouse */
static fix_item strminvm[] = {
  {0x0301DFC6UL, 0x2B},
  {0x0101DFD0UL, 0x29},
  {0x0101DFD6UL, 0x29},
  {0x2901DFDCUL, 0x01}
};

int main(int argc, char *argv[]) {
unsigned char b;
int fl, i, s;
  puts(
    "Alpha Storm invert mouse look v1.0\n"
    "(c) -=CHE@TER=- 2021\n"
    "e-mail: _CTPAX_@MAIL.RU\n"
    "http://ctpax-cheater.losthost.org/htmldocs/trouble.htm\n\n"
    "Usage: asimouse [/u]\n"
    "/u - undo, removes this fix if specified and revert all changes back.\n"
  );
  fl = open("STORM.EXE", O_RDWR | O_BINARY);
  if (fl == -1) {
    puts("Error: file \"STORM.EXE\" not found.\n");
    return(1);
  }
  lseek(fl, 0, SEEK_END);
  if (tell(fl) != 613895UL) {
    close(fl);
    puts("Error: unknown \"STORM.EXE\" file.\n");
    return(2);
  }
  s = 0;
  for (i = 0; i < LIST_LEN(strminvm); i++) {
    lseek(fl, GET_OFFS(strminvm[i].offs), SEEK_SET);
    read(fl, &b, 1);
    if (b == strminvm[i].data) {
      s++;
    } else {
      if (b != GET_BYTE(strminvm[i].offs)) {
        s = -1;
        break;
      }
    }
  }
  if ((!s) || (s == LIST_LEN(strminvm))) {
    if ((s) && (argc < 2)) {
      puts("Error: file \"STORM.EXE\" aready patched.\n");
      s = -1;
    }
    if ((!s) && (argc >= 2)) {
      puts("Error: file \"STORM.EXE\" aready original.\n");
      s = -1;
    }
    if (s != -1) {
      s = (argc < 2) && argv;
      for (i = 0; i < LIST_LEN(strminvm); i++) {
        lseek(fl, GET_OFFS(strminvm[i].offs), SEEK_SET);
        b = s ? strminvm[i].data : GET_BYTE(strminvm[i].offs);
        write(fl, &b, 1);
      }
      if (s) {
        puts("Ready: file \"STORM.EXE\" successfully patched.\n");
      } else {
        puts("Ready: file \"STORM.EXE\" restored to original.\n");
      }
    }
  } else {
    puts("Error: invalid \"STORM.EXE\" file.\n");
  }
  close(fl);
  return(0);
}
